(define table
  `([main [("apple") ,(lambda () 'apple)]
          [("banana") ,(lambda () 'banana)]
          [(fruit-salad "!") ,(lambda (x)
                                `(x ,!))]]
    [fruit-salad [(fruit fruit) ,(lambda (x y)
                                   (list x y))]
                 [(fruit fruit fruit) ,(lambda (x y z)
                                         (list x y z))]]
    [fruit [("orange") ,(lambda ()'orange)]
           [("grape") ,(lambda () 'grape)]]))

(define (parse what table stream)
  (local [(define defn (assq what table))]
    (if defn
        (parse-alts (rest defn) table stream)
        (error 'parse "no definition for ~a" what))))

(define (parse-alts alts table stream)
  (if (null? alts)
      false
      (or (parse-case (first alts) table stream)
          (parse-alts (rest alts) table stream))))

(define (parse-case case table stream)
  (local [(define seq (first case))
          (define handler (second case))]
    (local [(define parsed (parse-sequence seq table stream))]
      (and parsed
           (apply handler parsed)))))

(define (parse-sequence seq table stream)
  (cond
    [(empty? seq) empty]
    [else (local [(define first-parsed 
                    (parse-item (first seq) table stream))]
            (and first-parsed
                 (local [(define rest-parsed
                           (parse-sequence (rest seq) table stream))]
                   (and rest-parsed
                        (append first-parsed rest-parsed)))))]))

(define (parse-item item table stream)
  (cond
    [(string? item)
     (if (and (cons? stream)
              (equal? item (first stream)))
         empty
         false)]
    [else
     (let ([x (parse item table stream)])
       (and x (list x)))]))

(parse 'main table '("orange" "orange" "!"))

